#!/bin/bash
set -e

# Replace arguments by preprocessed arguments
TEMP=`getopt -o h --long configure,disable-scripting -- "$@"`
eval set -- "$TEMP"

TRUE=0
FALSE=1

. /opt/poky/3.1.20/environment-setup-armv5e-poky-linux-gnueabi
export SYSROOT_PREFIX=$SDKTARGETSYSROOT/usr

CONFIGURE=$FALSE
SCRIPTING=
while true; do
    case "$1" in
        --configure) CONFIGURE=$TRUE; shift;;
        --disable-scripting) SCRIPTING=$FALSE; shift;;
        --) shift; break;;
        *) break;;
    esac
done

if [ $CONFIGURE -eq $TRUE ]; then
  echo do configure
  autoreconf -i

  mkdir -p build-dss11
  cd build-dss11

  ../configure $CONFIGURE_FLAGS --prefix=/usr --with-search=$SYSROOT_PREFIX \
    ${SCRIPTING:+--disable-scripting} \
    --with-boost=$SYSROOT_PREFIX \
    --enable-debug \
    --enable-stack-protect \
    --enable-insecure-cookie \
    --disable-tests-autobuild \
    --sysconfdir=/etc
else
  cd build-dss11
fi

nice make -j $(nproc)
