#!/bin/bash
set -e

# needed for DS_OS_DIR
DOCKER_DIR="$(dirname $(realpath $0))"
. ${DOCKER_DIR}/env.sh

if docker ps >/dev/null 2>/dev/null; then
    DOCKER="docker"
elif sudo docker ps >/dev/null 2>/dev/null; then
    DOCKER="sudo docker"
else
    echo "Docker not found. Please install: https://docs.docker.com/engine/installation/";
    exit;
fi

DKRIMG="$(basename $(dirname $(dirname $(realpath $0))))"
VHOME="$(dirname $(realpath $0))/vhome"
echo image: $DKRIMG

USER=`id -un`

# Start new interactive container. Mount dss-oe folder inside.
$DOCKER run --rm -it \
    -v "${VHOME}:/home/${USER}":z \
    -v "${DS_OS_DIR}:${DS_OS_DIR}":z \
    --net=host \
    -e DISPLAY -v $HOME/.Xauthority:/home/${USER}/.Xauthority \
    -v $HOME/.ssh/known_hosts:/home/${USER}/.ssh/known_hosts \
    -e SSH_AUTH_SOCK=$SSH_AUTH_SOCK \
    -v "${SSH_AUTH_SOCK}:${SSH_AUTH_SOCK}":z \
    -e PS1="[\u@dkr-\h: \W]\$ " \
    -w ${DS_OS_DIR}/dss-mainline \
    ${DKRIMG} \
    bash
