#!/usr/bin/env python3

import csv, sys

filename = sys.argv[1]
reader = csv.reader(open(filename, 'r'), delimiter=',')

def fixumProductId(productName, vendorId):
    a = {
        "-JS": "JS",
        "-CS": "CS",
        "-CW": "CW",
        "-CT": "CT",
        "-FS": "FS",
        "-GW": "GW",
        "-E+F": "EF",
        "-F": "F",
        "-S": "S",
        "-W": "W",
    };

    productName = productName.replace('-', '_', 1)

    for (match, replace) in a.items():
       productName = productName.replace(match, replace)

    return productName

for row in reader:
    if row[0].startswith('#'):
        continue

    (productName, hardwareInfo, swCodeNr, gtin13, dsidPrefix, colorId, productId, vendorId) = row

    if int(vendorId) == 3:
        continue

    if (productName in { 'Weather', 'SW-TNY210'}):
        continue

    if (productName in { 'Permundo PSC234 dS'}):
        productName = hardwareInfo

    #print('{', productName, ',', colorId, ',', productId, ',', vendorId, '},')
    productEntry = "{{ HardwareType::{0}, {{ {1}, {2}, {3} }}}},"
    productName = fixumProductId(productName, vendorId)
    print(productEntry.format(productName, productId, vendorId, colorId))

