#!/bin/sh
#
# Install symlinks into `.git/hooks` targeting hooks committed in `git-hooks`
#

set -e
cd `git rev-parse --show-toplevel` > /dev/null

HOOKS="pre-commit"
for x in $HOOKS; do
    TARGET=../../git-hooks/$x
    LINK_NAME=.git/hooks/$x
    if [ -e $LINK_NAME ] || [ -L $LINK_NAME ]; then
        if [ -L $LINK_NAME ] && [ x`readlink $LINK_NAME` = x$TARGET ]; then
            true
        else
            echo Link $LINK_NAME is incorrect. Please remove and rerun.
            false
        fi
    else
        ln -s $TARGET $LINK_NAME
        echo Git hook $LINK_NAME installed
    fi
done
