/*
    Copyright (c) 2009,2011 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/
#pragma once

#include <trompeloeil.hpp>

#include "backend-vdcs.h"

namespace dss {

class BackendVdcsMock : public trompeloeil::mock_interface<BackendVdcs> {
  IMPLEMENT_MOCK2(notify);
  IMPLEMENT_MOCK1(reregister);
  IMPLEMENT_MOCK1(reregisterDevices);
  IMPLEMENT_MOCK0(structureQueryBusInterface);
  IMPLEMENT_MOCK0(structureModifyingBusInterface);

  IMPLEMENT_CONST_MOCK1(isBackendVdcDevice);
  IMPLEMENT_CONST_MOCK1(isBackendVdc);
  IMPLEMENT_CONST_MOCK1(vdcIdForDeviceDsuid);
  IMPLEMENT_CONST_MOCK1(vdcIdForDsuid);
  IMPLEMENT_CONST_MOCK1(vdcDsuidForId);

  IMPLEMENT_CONST_MOCK0(hasBackend);
  IMPLEMENT_CONST_MOCK0(hasVdcs);

  IMPLEMENT_CONST_MOCK3(http);
};

} // namespace dss
