#pragma once

#include <ds-api/service-fwd.h>
#include <ds/asio/resource-fwd.h>

#include <memory>

namespace dsApi {

/// Service hosted at /api/v1/inside
///
/// Intended for investigation by humans.
/// No api stability intended.
std::unique_ptr<dsApi::Service> makeInsideService();

/// Service hosted at /api/v1/test
///
/// Intended for automated tests.
/// Breaking api changes coordinated with autometed tests
std::unique_ptr<dsApi::Service> makeTestService();

} // namespace dsApi
