#pragma once

#include <ds-api/event-fwd.h>
#include <ds-model/apartment-api-fwd.h>
#include <ds-model/meterings.h> // std::variants need full type
#include <ds/asio/resource-fwd.h>

namespace dss {

class Apartment;

struct DecodedMeteringId {
  dsModel::MeteringOrigin origin{};
  dsModel::MeteringType meteringType{};
};

DecodedMeteringId decodeId(const dsModel::MeteringId&);
dsModel::MeteringId encodeId(const dsModel::MeteringOrigin&, dsModel::MeteringType);

std::unique_ptr<dsModel::MeteringsApi> makeDsMeterings(ds::asio::ResourceBase& parent, Apartment& apartment,
                                                       dsApi::EventHub& eventHub);

} // namespace dss

DS_REFLECT_STRUCT((dss), DecodedMeteringId, (origin)(meteringType));
