
/*
 This file is part of the digitalSTROM dsm-api library.

 Copyright (C) 2010-2018 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM dsm-api library is free software: you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 digitalSTROM dsm-api library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with digitalSTROM dsm-api library. If not, see <http://www.gnu.org/licenses/>.
 
 NOTE: The dsm-api library and it's script bindings are unsupported interfaces and
 subject to change without further notice.
 
 */
 /*
 * DO NOT MANUALLY MODIFY! 
 *
 * THIS FILE IS AUTOGENERATED FROM THE dSM-API XML DEFINITIONS IN
 * dsm-api.xml.
 * Make any changes in the XML definition and regenerate this file.
 */
#include "dsm-api-mock.h"

#include <ds/log.h>

DsmApi dsm_api_mock;

static ds::LogChannel dsLogChannel("dsmApiMock");

extern "C" {
int DsmApiLibraryVersion(void) {
    return dsm_api_mock.DsmApiLibraryVersion();
}
DsmApiHandle_t DsmApiInitialize(void) {
    return dsm_api_mock.DsmApiInitialize();
}
int DsmApiOpen(DsmApiHandle_t handle, const char *connection, int flags) {
    return dsm_api_mock.DsmApiOpen(handle, connection, flags);
}
int DsmApiGetOwnDSUID(DsmApiHandle_t handle, dsuid_t *dsuid) {
    return dsm_api_mock.DsmApiGetOwnDSUID(handle, dsuid);
}
int DsmApiGetBusMembers(DsmApiHandle_t handle, dsuid_t *device_list, int device_list_size) {
    return dsm_api_mock.DsmApiGetBusMembers(handle, device_list, device_list_size);
}
int DsmApiGetBusMembersPerType(DsmApiHandle_t handle, dsuid_t *device_list, int device_list_size, unsigned int types) {
    return dsm_api_mock.DsmApiGetBusMembersPerType(handle, device_list, device_list_size, types);
}
int DsmApiGetLinkState(DsmApiHandle_t handle, bool *state) {
    return dsm_api_mock.DsmApiGetLinkState(handle, state);
}
int DsmApiRestartBus(DsmApiHandle_t handle) {
    return dsm_api_mock.DsmApiRestartBus(handle);
}
int DsmApiClose(DsmApiHandle_t handle) {
    return dsm_api_mock.DsmApiClose(handle);
}
int DsmApiCleanup(DsmApiHandle_t handle) {
    return dsm_api_mock.DsmApiCleanup(handle);
}

int DsmApiSetCallback(DsmApiHandle_t handle, container_type_t MessageType, uint8_t MessageId, uint8_t ModifierId, DsmApiCallback_t *const callback, DsmApiCallback_t *oldcallback) {
    return dsm_api_mock.DsmApiSetCallback(handle, MessageType, MessageId, ModifierId, callback, oldcallback);
}
int DsmApiSetLinkStateCallback(DsmApiHandle_t handle, DsmApiCallback_t *const callback, DsmApiCallback_t *oldcallback) {
    return dsm_api_mock.DsmApiSetLinkStateCallback(handle, callback, oldcallback);
}
int DsmApiSetBusChangeCallback(DsmApiHandle_t handle, DsmApiCallback_t *const callback, DsmApiCallback_t *oldcallback) {
    return dsm_api_mock.DsmApiSetBusChangeCallback(handle, callback, oldcallback);
}
int DsmApiSetBlockingCallback(DsmApiHandle_t handle, DsmApiCallback_t *const callback, DsmApiCallback_t *oldcallback) {
    return dsm_api_mock.DsmApiSetBlockingCallback(handle, callback, oldcallback);
}

int DsmApiGetDeviceDSUID(uint16_t vendorId, uint16_t productId, uint8_t groupId, uint16_t revisionId, uint32_t serialNumber, dsuid_t *dsuid) {
    return dsm_api_mock.DsmApiGetDeviceDSUID(vendorId, productId, groupId, revisionId, serialNumber, dsuid);
}
int DsmApiGetEthernetDSUID(const char *mac, dsuid_t *dsuid) {
    return dsm_api_mock.DsmApiGetEthernetDSUID(mac, dsuid);
}
int DsmApiGetEthernetInfo(const char *mac, const char **gtin, const char **hwInfo) {
  return dsm_api_mock.DsmApiGetEthernetInfo(mac, gtin, hwInfo);
}
int DsmApiGetDeviceDescription(uint16_t vendorId, uint16_t productId, uint8_t groupId, uint16_t revisionId,
                               const char **displayName, const char **hardwareInfo, const char **gtin) {
  return dsm_api_mock.DsmApiGetDeviceDescription(vendorId, productId, groupId, revisionId, displayName, hardwareInfo,
                                                 gtin);
}
int DsmApiIsdSM(dsuid_t dSMdSUID) {
    return dsm_api_mock.DsmApiIsdSM(dSMdSUID);
}

int DeviceStatisticsRequest_get_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ParamOffset, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceStatisticsRequest_get_sync(handle, dSMdSUID, DeviceId, ParamOffset, timeout, Value);
}
int DeviceConfig_get_sync_8(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ConfigClass, uint8_t ConfigIndex, int timeout, uint8_t *Value) {
    return dsm_api_mock.DeviceConfig_get_sync_8(handle, dSMdSUID, DeviceId, ConfigClass, ConfigIndex, timeout, Value);
}
int DeviceConfig_get_sync_16(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ConfigClass, uint8_t ConfigIndex, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceConfig_get_sync_16(handle, dSMdSUID, DeviceId, ConfigClass, ConfigIndex, timeout, Value);
}
int DeviceConfig_set_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ConfigClass, uint8_t ConfigIndex, uint8_t Value, int timeout) {
    return dsm_api_mock.DeviceConfig_set_sync(handle, dSMdSUID, DeviceId, ConfigClass, ConfigIndex, Value, timeout);
}
int DeviceProperties_set_zone_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint16_t ZoneId, int timeout) {
    return dsm_api_mock.DeviceProperties_set_zone_sync(handle, dSMdSUID, DeviceId, ZoneId, timeout);
}
int DeviceProperties_set_button_set_output_channel_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ChannelId, int timeout) {
    return dsm_api_mock.DeviceProperties_set_button_set_output_channel_sync(handle, dSMdSUID, DeviceId, ChannelId, timeout);
}
int DeviceProperties_set_button_active_group_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t GroupId, int timeout) {
    return dsm_api_mock.DeviceProperties_set_button_active_group_sync(handle, dSMdSUID, DeviceId, GroupId, timeout);
}
int DeviceGroupMembershipModify_add_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t GroupId, int timeout) {
    return dsm_api_mock.DeviceGroupMembershipModify_add_sync(handle, dSMdSUID, DeviceId, GroupId, timeout);
}
int DeviceOPCConfig_get_current_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ChannelId, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceOPCConfig_get_current_sync(handle, dSMdSUID, DeviceId, ChannelId, timeout, Value);
}
int DeviceOPCConfig_get_scene_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t ChannelId, uint8_t SceneId, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceOPCConfig_get_scene_sync(handle, dSMdSUID, DeviceId, ChannelId, SceneId, timeout, Value);
}
int DeviceOPCConfig_get_scene_config_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t SceneId, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceOPCConfig_get_scene_config_sync(handle, dSMdSUID, DeviceId, SceneId, timeout, Value);
}
int DeviceOPCConfig_get_dc_flags_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t SceneId, int timeout, uint16_t *Value) {
    return dsm_api_mock.DeviceOPCConfig_get_dc_flags_sync(handle, dSMdSUID, DeviceId, SceneId, timeout, Value);
}
int TestTransmissionQuality_get_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, int timeout, uint8_t *DownstreamQuality, uint16_t *UpstreamQuality) {
    return dsm_api_mock.TestTransmissionQuality_get_sync(handle, dSMdSUID, DeviceId, timeout, DownstreamQuality, UpstreamQuality);
}
int DeviceSensor_get_value_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t SensorIndex, int timeout, uint16_t *SensorValue) {
    return dsm_api_mock.DeviceSensor_get_value_sync(handle, dSMdSUID, DeviceId, SensorIndex, timeout, SensorValue);
}
int DeviceSensor_get_value_extended_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t SensorIndex, int timeout, double *SensorValue, uint32_t *valueAge, uint32_t *contextId, uint8_t *contextMsg) {
    return dsm_api_mock.DeviceSensor_get_value_extended_sync(handle, dSMdSUID, DeviceId, SensorIndex, timeout, SensorValue, valueAge, contextId, contextMsg);
}
int DeviceDslinkSend_not_last_byte_with_answer_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t Value, int timeout, uint8_t *ReturnValue) {
    return dsm_api_mock.DeviceDslinkSend_not_last_byte_with_answer_sync(handle, dSMdSUID, DeviceId, Value, timeout, ReturnValue);
}
int DeviceDslinkSend_last_byte_with_answer_sync(DsmApiHandle_t handle, dsuid_t dSMdSUID, uint16_t DeviceId, uint8_t Value, int timeout, uint8_t *ReturnValue) {
    return dsm_api_mock.DeviceDslinkSend_last_byte_with_answer_sync(handle, dSMdSUID, DeviceId, Value, timeout, ReturnValue);
}

int ClusterInfo_by_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t *ApplicationType, uint8_t *HasStateMachine, uint16_t *NumberOfDevices, uint8_t *Name, uint8_t *StopTimeout, uint8_t *RemoteStopTimeout, uint8_t *ConfigurationLock, uint8_t *SceneLock, uint16_t *Location, uint16_t *Floor, uint16_t *ProtectionClass, uint32_t *ApplicationConfiguration)
{
    return dsm_api_mock.ClusterInfo_by_id(handle, dS485DeviceUID, ClusterId, ApplicationType, HasStateMachine, NumberOfDevices, Name, StopTimeout, RemoteStopTimeout, ConfigurationLock, SceneLock, Location, Floor, ProtectionClass, ApplicationConfiguration);
}

int ClusterProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, const uint8_t *Name)
{
    return dsm_api_mock.ClusterProperties_set_name(handle, dS485DeviceUID, ClusterId, Name);
}

int ClusterProperties_set_stop_timeout(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t StopTimeout)
{
    return dsm_api_mock.ClusterProperties_set_stop_timeout(handle, dS485DeviceUID, ClusterId, StopTimeout);
}

int ClusterProperties_set_state_machine(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t StateMachine)
{
    return dsm_api_mock.ClusterProperties_set_state_machine(handle, dS485DeviceUID, ClusterId, StateMachine);
}

int ClusterProperties_set_location_class(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint16_t Location, uint16_t Floor, uint16_t ProtectionClass)
{
    return dsm_api_mock.ClusterProperties_set_location_class(handle, dS485DeviceUID, ClusterId, Location, Floor, ProtectionClass);
}

int ClusterProperties_set_configuration_lock(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t ConfigurationLock)
{
    return dsm_api_mock.ClusterProperties_set_configuration_lock(handle, dS485DeviceUID, ClusterId, ConfigurationLock);
}

int ClusterProperties_set_scene_lock(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, const uint8_t *SceneLock)
{
    return dsm_api_mock.ClusterProperties_set_scene_lock(handle, dS485DeviceUID, ClusterId, SceneLock);
}

int ClusterProperties_get_operation_lock(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t *OperationLock)
{
    return dsm_api_mock.ClusterProperties_get_operation_lock(handle, dS485DeviceUID, ClusterId, OperationLock);
}

int ClusterProperties_set_application(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t ApplicationType, uint32_t ApplicationConfiguration)
{
    return dsm_api_mock.ClusterProperties_set_application(handle, dS485DeviceUID, ClusterId, ApplicationType, ApplicationConfiguration);
}

int ClusterProperties_get_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t *State)
{
    return dsm_api_mock.ClusterProperties_get_state(handle, dS485DeviceUID, ClusterId, State);
}

int ClusterProperties_set_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ClusterId, uint8_t State)
{
    return dsm_api_mock.ClusterProperties_set_state(handle, dS485DeviceUID, ClusterId, State);
}

int EventGeneric(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t EventType, uint8_t PayloadLength, const uint8_t *Payload)
{
    return dsm_api_mock.EventGeneric(handle, dS485DeviceUID, EventType, PayloadLength, Payload);
}

int ZoneCount(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *ZoneCount)
{
    return dsm_api_mock.ZoneCount(handle, dS485DeviceUID, ZoneCount);
}

int ZoneInfo_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ZoneIndex, uint16_t *ZoneId, uint8_t *VirtualZoneId, uint8_t *NumberOfGroups, uint8_t *Name)
{
    return dsm_api_mock.ZoneInfo_by_index(handle, dS485DeviceUID, ZoneIndex, ZoneId, VirtualZoneId, NumberOfGroups, Name);
}

int ZoneInfo_by_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneIdReq, uint16_t *ZoneId, uint8_t *VirtualZoneId, uint8_t *NumberOfGroups, uint8_t *Name)
{
    return dsm_api_mock.ZoneInfo_by_id(handle, dS485DeviceUID, ZoneIdReq, ZoneId, VirtualZoneId, NumberOfGroups, Name);
}

int ZoneModify_add(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId)
{
    return dsm_api_mock.ZoneModify_add(handle, dS485DeviceUID, ZoneId);
}

int ZoneModify_remove(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId)
{
    return dsm_api_mock.ZoneModify_remove(handle, dS485DeviceUID, ZoneId);
}

int ZoneModify_change_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t NewZoneId)
{
    return dsm_api_mock.ZoneModify_change_id(handle, dS485DeviceUID, ZoneId, NewZoneId);
}

int ZoneDeviceCount_only_active(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *NumberOfDevices)
{
    return dsm_api_mock.ZoneDeviceCount_only_active(handle, dS485DeviceUID, ZoneId, NumberOfDevices);
}

int ZoneDeviceCount_only_inactive(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *NumberOfDevices)
{
    return dsm_api_mock.ZoneDeviceCount_only_inactive(handle, dS485DeviceUID, ZoneId, NumberOfDevices);
}

int ZoneDeviceCount_all(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *NumberOfDevices)
{
    return dsm_api_mock.ZoneDeviceCount_all(handle, dS485DeviceUID, ZoneId, NumberOfDevices);
}

int ZoneProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, const uint8_t *Name)
{
    return dsm_api_mock.ZoneProperties_set_name(handle, dS485DeviceUID, ZoneId, Name);
}

int ZoneProperties_get_scene_history(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t *HistorySize, uint8_t *GroupId_0, uint8_t *Scene_0, uint8_t *GroupId_1, uint8_t *Scene_1, uint8_t *GroupId_2, uint8_t *Scene_2, uint8_t *GroupId_3, uint8_t *Scene_3, uint8_t *GroupId_4, uint8_t *Scene_4, uint8_t *GroupId_5, uint8_t *Scene_5, uint8_t *GroupId_6, uint8_t *Scene_6)
{
    return dsm_api_mock.ZoneProperties_get_scene_history(handle, dS485DeviceUID, ZoneId, HistorySize, GroupId_0, Scene_0, GroupId_1, Scene_1, GroupId_2, Scene_2, GroupId_3, Scene_3, GroupId_4, Scene_4, GroupId_5, Scene_5, GroupId_6, Scene_6);
}

int ZoneProperties_get_room_states(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *Room, uint16_t *Area1, uint16_t *Area2, uint16_t *Area3, uint16_t *Area4)
{
    return dsm_api_mock.ZoneProperties_get_room_states(handle, dS485DeviceUID, ZoneId, Room, Area1, Area2, Area3, Area4);
}

int ZoneProperties_set_zone_sensor(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t SensorType, dsuid_t dSUID)
{
    return dsm_api_mock.ZoneProperties_set_zone_sensor(handle, dS485DeviceUID, ZoneId, SensorType, dSUID);
}

int ZoneProperties_get_zone_sensor(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t SensorType, dsuid_t *dSUID)
{
    return dsm_api_mock.ZoneProperties_get_zone_sensor(handle, dS485DeviceUID, ZoneId, SensorType, dSUID);
}

int ZoneProperties_reset_zone_sensor(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t SensorType)
{
    return dsm_api_mock.ZoneProperties_reset_zone_sensor(handle, dS485DeviceUID, ZoneId, SensorType);
}

int ZoneProperties_get_zone_sensor_value(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t SensorType, uint16_t *SensorValue, uint32_t *SensorAge)
{
    return dsm_api_mock.ZoneProperties_get_zone_sensor_value(handle, dS485DeviceUID, ZoneId, SensorType, SensorValue, SensorAge);
}

int ZoneGroupModify_add(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t ApplicationType)
{
    return dsm_api_mock.ZoneGroupModify_add(handle, dS485DeviceUID, ZoneId, GroupId, ApplicationType);
}

int ZoneGroupModify_remove(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId)
{
    return dsm_api_mock.ZoneGroupModify_remove(handle, dS485DeviceUID, ZoneId, GroupId);
}

int ZoneGroupInfo_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t Index, uint8_t *GroupId, uint8_t *ApplicationType, uint16_t *NumberOfDevices, uint8_t *Name, uint8_t *StopTimeout, uint8_t *RemoteStopTimeout, uint32_t *ApplicationConfiguration)
{
    return dsm_api_mock.ZoneGroupInfo_by_index(handle, dS485DeviceUID, ZoneId, Index, GroupId, ApplicationType, NumberOfDevices, Name, StopTimeout, RemoteStopTimeout, ApplicationConfiguration);
}

int ZoneGroupInfo_by_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupIdReq, uint8_t *GroupId, uint8_t *ApplicationType, uint16_t *NumberOfDevices, uint8_t *Name, uint8_t *StopTimeout, uint8_t *RemoteStopTimeout, uint32_t *ApplicationConfiguration)
{
    return dsm_api_mock.ZoneGroupInfo_by_id(handle, dS485DeviceUID, ZoneId, GroupIdReq, GroupId, ApplicationType, NumberOfDevices, Name, StopTimeout, RemoteStopTimeout, ApplicationConfiguration);
}

int ZoneGroupProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, const uint8_t *Name)
{
    return dsm_api_mock.ZoneGroupProperties_set_name(handle, dS485DeviceUID, ZoneId, GroupId, Name);
}

int ZoneGroupProperties_set_stop_timeout(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t StopTimeout)
{
    return dsm_api_mock.ZoneGroupProperties_set_stop_timeout(handle, dS485DeviceUID, ZoneId, GroupId, StopTimeout);
}

int ZoneGroupProperties_set_state_machine(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t StateMachine)
{
    return dsm_api_mock.ZoneGroupProperties_set_state_machine(handle, dS485DeviceUID, ZoneId, GroupId, StateMachine);
}

int ZoneGroupProperties_set_application(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t ApplicationType, uint32_t ApplicationConfiguration)
{
    return dsm_api_mock.ZoneGroupProperties_set_application(handle, dS485DeviceUID, ZoneId, GroupId, ApplicationType, ApplicationConfiguration);
}

int ZoneGroupProperties_get_scene_history(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t *HistorySize, uint8_t *GroupId_0, uint8_t *Scene_0, uint8_t *Flags_0, uint8_t *Entry_1, uint8_t *Entry_2, uint8_t *Entry_3, uint8_t *Entry_4, uint8_t *Entry_5, uint8_t *Entry_6)
{
    return dsm_api_mock.ZoneGroupProperties_get_scene_history(handle, dS485DeviceUID, ZoneId, GroupId, HistorySize, GroupId_0, Scene_0, Flags_0, Entry_1, Entry_2, Entry_3, Entry_4, Entry_5, Entry_6);
}

int ZoneGroupProperties_set_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t Zone, uint8_t Area1, uint8_t Area2, uint8_t Area3, uint8_t Area4)
{
    return dsm_api_mock.ZoneGroupProperties_set_state(handle, dS485DeviceUID, ZoneId, GroupId, Zone, Area1, Area2, Area3, Area4);
}

int ControllerHeating_set_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t ControllerMode, uint16_t Kp, uint8_t Ts, uint16_t Ti, uint16_t Kd, uint16_t Imin, uint16_t Imax, uint8_t Ymin, uint8_t Ymax, uint8_t AntiWindUp, uint8_t KeepFloorWarm, uint16_t SourceZoneId, uint16_t Offset, uint8_t ManualValue, uint8_t EmergencyValue)
{
    return dsm_api_mock.ControllerHeating_set_config(handle, dS485DeviceUID, ZoneId, ControllerMode, Kp, Ts, Ti, Kd, Imin, Imax, Ymin, Ymax, AntiWindUp, KeepFloorWarm, SourceZoneId, Offset, ManualValue, EmergencyValue);
}

int ControllerHeating_get_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t *ControllerMode, uint16_t *Kp, uint8_t *Ts, uint16_t *Ti, uint16_t *Kd, uint16_t *Imin, uint16_t *Imax, uint8_t *Ymin, uint8_t *Ymax, uint8_t *AntiWindUp, uint8_t *KeepFloorWarm, uint16_t *SourceZoneId, uint16_t *Offset, uint8_t *ManualValue, uint8_t *EmergencyValue)
{
    return dsm_api_mock.ControllerHeating_get_config(handle, dS485DeviceUID, ZoneId, ControllerMode, Kp, Ts, Ti, Kd, Imin, Imax, Ymin, Ymax, AntiWindUp, KeepFloorWarm, SourceZoneId, Offset, ManualValue, EmergencyValue);
}

int ControllerHeating_get_internals(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *t, uint16_t *tref, uint16_t *E, uint16_t *Eprev, uint32_t *Integral, uint32_t *Yp, uint32_t *Yi, uint32_t *Yd, uint8_t *Y, uint8_t *AntiWindUp)
{
    return dsm_api_mock.ControllerHeating_get_internals(handle, dS485DeviceUID, ZoneId, t, tref, E, Eprev, Integral, Yp, Yi, Yd, Y, AntiWindUp);
}

int ControllerHeating_set_operation_modes(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t OperationMode0, uint16_t OperationMode1, uint16_t OperationMode2, uint16_t OperationMode3, uint16_t OperationMode4, uint16_t OperationMode5, uint16_t OperationMode6, uint16_t OperationMode7, uint16_t OperationMode8, uint16_t OperationMode9, uint16_t OperationMode10, uint16_t OperationMode11, uint16_t OperationMode12, uint16_t OperationMode13, uint16_t OperationMode14, uint16_t OperationMode15)
{
    return dsm_api_mock.ControllerHeating_set_operation_modes(handle, dS485DeviceUID, ZoneId, OperationMode0, OperationMode1, OperationMode2, OperationMode3, OperationMode4, OperationMode5, OperationMode6, OperationMode7, OperationMode8, OperationMode9, OperationMode10, OperationMode11, OperationMode12, OperationMode13, OperationMode14, OperationMode15);
}

int ControllerHeating_get_operation_modes(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint16_t *OperationMode0, uint16_t *OperationMode1, uint16_t *OperationMode2, uint16_t *OperationMode3, uint16_t *OperationMode4, uint16_t *OperationMode5, uint16_t *OperationMode6, uint16_t *OperationMode7, uint16_t *OperationMode8, uint16_t *OperationMode9, uint16_t *OperationMode10, uint16_t *OperationMode11, uint16_t *OperationMode12, uint16_t *OperationMode13, uint16_t *OperationMode14, uint16_t *OperationMode15)
{
    return dsm_api_mock.ControllerHeating_get_operation_modes(handle, dS485DeviceUID, ZoneId, OperationMode0, OperationMode1, OperationMode2, OperationMode3, OperationMode4, OperationMode5, OperationMode6, OperationMode7, OperationMode8, OperationMode9, OperationMode10, OperationMode11, OperationMode12, OperationMode13, OperationMode14, OperationMode15);
}

int ControllerHeating_set_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t State)
{
    return dsm_api_mock.ControllerHeating_set_state(handle, dS485DeviceUID, ZoneId, State);
}

int ControllerHeating_get_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t *State)
{
    return dsm_api_mock.ControllerHeating_get_state(handle, dS485DeviceUID, ZoneId, State);
}

int ZoneGroupSceneInfo(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t SceneId, uint8_t *Name)
{
    return dsm_api_mock.ZoneGroupSceneInfo(handle, dS485DeviceUID, ZoneId, GroupId, SceneId, Name);
}

int ZoneGroupSceneProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t SceneId, const uint8_t *Name)
{
    return dsm_api_mock.ZoneGroupSceneProperties_set_name(handle, dS485DeviceUID, ZoneId, GroupId, SceneId, Name);
}

int ZoneGroupActionRequest_action_call_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_call_scene(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_save_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_save_scene(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_undo_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_undo_scene(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_blink(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_blink(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_undo_scene_number(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_undo_scene_number(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_force_call_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_force_call_scene(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_set_outval(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t Value)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_set_outval(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, Value);
}

int ZoneGroupActionRequest_action_set_scene_local_priority(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_set_scene_local_priority(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_programming_mode_on(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_programming_mode_on(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_programming_mode_off(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_programming_mode_off(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_select_group(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_select_group(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_register_scene_local_priority(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_register_scene_local_priority(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_call_scene_min(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t SceneId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_call_scene_min(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, SceneId);
}

int ZoneGroupActionRequest_action_local_stop(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_local_stop(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupActionRequest_action_opc_inc(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_opc_inc(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, ChannelId);
}

int ZoneGroupActionRequest_action_opc_dec(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_opc_dec(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, ChannelId);
}

int ZoneGroupActionRequest_action_opc_stop(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_opc_stop(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, ChannelId);
}

int ZoneGroupActionRequest_action_extra_command(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId, uint8_t Command)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_extra_command(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId, Command);
}

int ZoneGroupActionRequest_action_fire_mute(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint16_t OriginDeviceId)
{
    return dsm_api_mock.ZoneGroupActionRequest_action_fire_mute(handle, dS485DeviceUID, ZoneId, GroupId, OriginDeviceId);
}

int ZoneGroupSensorPush(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, dsuid_t dSUID, uint8_t SensorType, uint16_t Value, uint8_t Precision)
{
    return dsm_api_mock.ZoneGroupSensorPush(handle, dS485DeviceUID, ZoneId, GroupId, dSUID, SensorType, Value, Precision);
}

int DeviceInfo_by_index_only_active(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneIdReq, uint16_t DeviceIndex, uint16_t *DeviceId, uint16_t *VendorId, uint16_t *ProductId, uint16_t *FunctionId, uint16_t *Version, uint16_t *ZoneId, uint8_t *State, uint8_t *Locked, uint8_t *OutputMode, uint8_t *LTMode, uint8_t *Groups, uint8_t *Name, dsuid_t *dSUID, uint8_t *ActiveGroup, uint8_t *DefaultGroup)
{
    return dsm_api_mock.DeviceInfo_by_index_only_active(handle, dS485DeviceUID, ZoneIdReq, DeviceIndex, DeviceId, VendorId, ProductId, FunctionId, Version, ZoneId, State, Locked, OutputMode, LTMode, Groups, Name, dSUID, ActiveGroup, DefaultGroup);
}

int DeviceInfo_by_index_only_inactive(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneIdReq, uint16_t DeviceIndex, uint16_t *DeviceId, uint16_t *VendorId, uint16_t *ProductId, uint16_t *FunctionId, uint16_t *Version, uint16_t *ZoneId, uint8_t *State, uint8_t *Locked, uint8_t *OutputMode, uint8_t *LTMode, uint8_t *Groups, uint8_t *Name, dsuid_t *dSUID, uint8_t *ActiveGroup, uint8_t *DefaultGroup)
{
    return dsm_api_mock.DeviceInfo_by_index_only_inactive(handle, dS485DeviceUID, ZoneIdReq, DeviceIndex, DeviceId, VendorId, ProductId, FunctionId, Version, ZoneId, State, Locked, OutputMode, LTMode, Groups, Name, dSUID, ActiveGroup, DefaultGroup);
}

int DeviceInfo_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneIdReq, uint16_t DeviceIndex, uint16_t *DeviceId, uint16_t *VendorId, uint16_t *ProductId, uint16_t *FunctionId, uint16_t *Version, uint16_t *ZoneId, uint8_t *State, uint8_t *Locked, uint8_t *OutputMode, uint8_t *LTMode, uint8_t *Groups, uint8_t *Name, dsuid_t *dSUID, uint8_t *ActiveGroup, uint8_t *DefaultGroup)
{
    return dsm_api_mock.DeviceInfo_by_index(handle, dS485DeviceUID, ZoneIdReq, DeviceIndex, DeviceId, VendorId, ProductId, FunctionId, Version, ZoneId, State, Locked, OutputMode, LTMode, Groups, Name, dSUID, ActiveGroup, DefaultGroup);
}

int DeviceInfo_by_device_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceIdReq, uint16_t *DeviceId, uint16_t *VendorId, uint16_t *ProductId, uint16_t *FunctionId, uint16_t *Version, uint16_t *ZoneId, uint8_t *State, uint8_t *Locked, uint8_t *OutputMode, uint8_t *LTMode, uint8_t *Groups, uint8_t *Name, dsuid_t *dSUID, uint8_t *ActiveGroup, uint8_t *DefaultGroup)
{
    return dsm_api_mock.DeviceInfo_by_device_id(handle, dS485DeviceUID, DeviceIdReq, DeviceId, VendorId, ProductId, FunctionId, Version, ZoneId, State, Locked, OutputMode, LTMode, Groups, Name, dSUID, ActiveGroup, DefaultGroup);
}

int DeviceState(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t *ActiveFlag)
{
    return dsm_api_mock.DeviceState(handle, dS485DeviceUID, DeviceId, ActiveFlag);
}

int DeviceStatisticsRequest_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ParamOffset)
{
    return dsm_api_mock.DeviceStatisticsRequest_get(handle, dS485DeviceUID, DeviceId, ParamOffset);
}

int DeviceProperties_set_zone(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint16_t ZoneId)
{
    return dsm_api_mock.DeviceProperties_set_zone(handle, dS485DeviceUID, DeviceId, ZoneId);
}

int DeviceProperties_set_locked_flag(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t LockedFlag)
{
    return dsm_api_mock.DeviceProperties_set_locked_flag(handle, dS485DeviceUID, DeviceId, LockedFlag);
}

int DeviceProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, const uint8_t *Name)
{
    return dsm_api_mock.DeviceProperties_set_name(handle, dS485DeviceUID, DeviceId, Name);
}

int DeviceProperties_set_button_active_group(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t GroupId)
{
    return dsm_api_mock.DeviceProperties_set_button_active_group(handle, dS485DeviceUID, DeviceId, GroupId);
}

int DeviceProperties_set_button_set_local_priority(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SetLocalPriority)
{
    return dsm_api_mock.DeviceProperties_set_button_set_local_priority(handle, dS485DeviceUID, DeviceId, SetLocalPriority);
}

int DeviceProperties_set_button_set_no_coming_home_call(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t NoComingHomeCall)
{
    return dsm_api_mock.DeviceProperties_set_button_set_no_coming_home_call(handle, dS485DeviceUID, DeviceId, NoComingHomeCall);
}

int DeviceProperties_set_button_set_apartment(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t WholeApartment)
{
    return dsm_api_mock.DeviceProperties_set_button_set_apartment(handle, dS485DeviceUID, DeviceId, WholeApartment);
}

int DeviceProperties_set_button_set_output_channel(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.DeviceProperties_set_button_set_output_channel(handle, dS485DeviceUID, DeviceId, ChannelId);
}

int DeviceButtonInfo_by_device(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t *ButtonId, uint8_t *DeprecatedGroupIfUpTo15, uint8_t *Group, uint8_t *Flags, uint8_t *ChannelId, uint8_t *GlobalGroup)
{
    return dsm_api_mock.DeviceButtonInfo_by_device(handle, dS485DeviceUID, DeviceId, ButtonId, DeprecatedGroupIfUpTo15, Group, Flags, ChannelId, GlobalGroup);
}

int DeviceBinaryInput_get_count(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t *Count)
{
    return dsm_api_mock.DeviceBinaryInput_get_count(handle, dS485DeviceUID, DeviceId, Count);
}

int DeviceBinaryInput_get_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t InputIndex, uint8_t *TargetGroupType, uint8_t *TargetGroup, uint8_t *BinaryInputType, uint8_t *ButtonId, uint8_t *Independent)
{
    return dsm_api_mock.DeviceBinaryInput_get_by_index(handle, dS485DeviceUID, DeviceId, InputIndex, TargetGroupType, TargetGroup, BinaryInputType, ButtonId, Independent);
}

int DeviceGroupMembershipModify_add(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t GroupId)
{
    return dsm_api_mock.DeviceGroupMembershipModify_add(handle, dS485DeviceUID, DeviceId, GroupId);
}

int DeviceGroupMembershipModify_remove(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t GroupId)
{
    return dsm_api_mock.DeviceGroupMembershipModify_remove(handle, dS485DeviceUID, DeviceId, GroupId);
}

int TestTransmissionQuality_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.TestTransmissionQuality_get(handle, dS485DeviceUID, DeviceId);
}

int TestDevicePresence(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.TestDevicePresence(handle, dS485DeviceUID, DeviceId);
}

int DeviceActionRequest_action_call_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceActionRequest_action_call_scene(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceActionRequest_action_save_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceActionRequest_action_save_scene(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceActionRequest_action_undo_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.DeviceActionRequest_action_undo_scene(handle, dS485DeviceUID, DeviceId);
}

int DeviceActionRequest_action_blink(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.DeviceActionRequest_action_blink(handle, dS485DeviceUID, DeviceId);
}

int DeviceActionRequest_action_undo_scene_number(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceActionRequest_action_undo_scene_number(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceActionRequest_action_force_call_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceActionRequest_action_force_call_scene(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceActionRequest_action_set_outval(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Value)
{
    return dsm_api_mock.DeviceActionRequest_action_set_outval(handle, dS485DeviceUID, DeviceId, Value);
}

int DeviceActionRequest_action_programming_mode_on(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.DeviceActionRequest_action_programming_mode_on(handle, dS485DeviceUID, DeviceId);
}

int DeviceActionRequest_action_programming_mode_off(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.DeviceActionRequest_action_programming_mode_off(handle, dS485DeviceUID, DeviceId);
}

int DeviceActionRequest_action_opc_inc(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.DeviceActionRequest_action_opc_inc(handle, dS485DeviceUID, DeviceId, ChannelId);
}

int DeviceActionRequest_action_opc_dec(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.DeviceActionRequest_action_opc_dec(handle, dS485DeviceUID, DeviceId, ChannelId);
}

int DeviceActionRequest_action_opc_stop(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.DeviceActionRequest_action_opc_stop(handle, dS485DeviceUID, DeviceId, ChannelId);
}

int DeviceActionRequest_action_extra_command(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Command)
{
    return dsm_api_mock.DeviceActionRequest_action_extra_command(handle, dS485DeviceUID, DeviceId, Command);
}

int DeviceConfig_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ConfigClass, uint8_t ConfigIndex)
{
    return dsm_api_mock.DeviceConfig_get(handle, dS485DeviceUID, DeviceId, ConfigClass, ConfigIndex);
}

int DeviceConfig_set(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ConfigClass, uint8_t ConfigIndex, uint8_t Value)
{
    return dsm_api_mock.DeviceConfig_set(handle, dS485DeviceUID, DeviceId, ConfigClass, ConfigIndex, Value);
}

int DeviceConfig_trigger_readout(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, dsuid_t dSUID)
{
    return dsm_api_mock.DeviceConfig_trigger_readout(handle, dS485DeviceUID, dSUID);
}

int DeviceOPCConfig_get_current(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId)
{
    return dsm_api_mock.DeviceOPCConfig_get_current(handle, dS485DeviceUID, DeviceId, ChannelId);
}

int DeviceOPCConfig_set_current_and_apply(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId, uint8_t Size, uint16_t Value)
{
    return dsm_api_mock.DeviceOPCConfig_set_current_and_apply(handle, dS485DeviceUID, DeviceId, ChannelId, Size, Value);
}

int DeviceOPCConfig_set_current(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId, uint8_t Size, uint16_t Value)
{
    return dsm_api_mock.DeviceOPCConfig_set_current(handle, dS485DeviceUID, DeviceId, ChannelId, Size, Value);
}

int DeviceOPCConfig_get_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceOPCConfig_get_scene(handle, dS485DeviceUID, DeviceId, ChannelId, SceneId);
}

int DeviceOPCConfig_set_scene(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t ChannelId, uint8_t Size, uint8_t SceneId, uint16_t Value)
{
    return dsm_api_mock.DeviceOPCConfig_set_scene(handle, dS485DeviceUID, DeviceId, ChannelId, Size, SceneId, Value);
}

int DeviceOPCConfig_get_scene_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceOPCConfig_get_scene_config(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceOPCConfig_set_scene_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId, uint16_t Value)
{
    return dsm_api_mock.DeviceOPCConfig_set_scene_config(handle, dS485DeviceUID, DeviceId, SceneId, Value);
}

int DeviceOPCConfig_get_dc_flags(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId)
{
    return dsm_api_mock.DeviceOPCConfig_get_dc_flags(handle, dS485DeviceUID, DeviceId, SceneId);
}

int DeviceOPCConfig_set_dc_flags(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SceneId, uint16_t Value)
{
    return dsm_api_mock.DeviceOPCConfig_set_dc_flags(handle, dS485DeviceUID, DeviceId, SceneId, Value);
}

int DeviceOPCTable_get_count(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t *Count)
{
    return dsm_api_mock.DeviceOPCTable_get_count(handle, dS485DeviceUID, DeviceId, Count);
}

int DeviceOPCTable_get_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Index, uint8_t *ChannelId)
{
    return dsm_api_mock.DeviceOPCTable_get_by_index(handle, dS485DeviceUID, DeviceId, Index, ChannelId);
}

int DeviceSensor_get_value(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SensorIndex)
{
    return dsm_api_mock.DeviceSensor_get_value(handle, dS485DeviceUID, DeviceId, SensorIndex);
}

int DeviceSensor_get_count(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t *Count)
{
    return dsm_api_mock.DeviceSensor_get_count(handle, dS485DeviceUID, DeviceId, Count);
}

int DeviceSensor_get_by_index(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SensorIndex, uint8_t *Type, uint32_t *PollInterval, uint8_t *Broadcast, uint8_t *PushConvert)
{
    return dsm_api_mock.DeviceSensor_get_by_index(handle, dS485DeviceUID, DeviceId, SensorIndex, Type, PollInterval, Broadcast, PushConvert);
}

int DeviceSensor_get_value_extended(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t SensorIndex)
{
    return dsm_api_mock.DeviceSensor_get_value_extended(handle, dS485DeviceUID, DeviceId, SensorIndex);
}

int CircuitRemoveInactiveDevices(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.CircuitRemoveInactiveDevices(handle, dS485DeviceUID);
}

int CircuitRemoveDevice_by_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId)
{
    return dsm_api_mock.CircuitRemoveDevice_by_id(handle, dS485DeviceUID, DeviceId);
}

int CircuitRemoveDevice_by_dsuid(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, dsuid_t dSUID)
{
    return dsm_api_mock.CircuitRemoveDevice_by_dsuid(handle, dS485DeviceUID, dSUID);
}

int CircuitPingDevices_automatic(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t IntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_automatic(handle, dS485DeviceUID, IntervalTime);
}

int CircuitPingDevices_one_time_automatic(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t OneTimeIntervalTime, uint16_t AutoIntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_one_time_automatic(handle, dS485DeviceUID, OneTimeIntervalTime, AutoIntervalTime);
}

int CircuitPingDevices_one_time_off(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t IntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_one_time_off(handle, dS485DeviceUID, IntervalTime);
}

int CircuitPingDevices_off(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.CircuitPingDevices_off(handle, dS485DeviceUID);
}

int CircuitPingDevices_automatic_s(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t IntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_automatic_s(handle, dS485DeviceUID, IntervalTime);
}

int CircuitPingDevices_one_time_automatic_s(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t OneTimeIntervalTime, uint16_t AutoIntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_one_time_automatic_s(handle, dS485DeviceUID, OneTimeIntervalTime, AutoIntervalTime);
}

int CircuitPingDevices_one_time_off_s(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t IntervalTime)
{
    return dsm_api_mock.CircuitPingDevices_one_time_off_s(handle, dS485DeviceUID, IntervalTime);
}

int CircuitEnergyMeterValue_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *PowerW, uint32_t *EnergyWh,
                                uint32_t *PowerProducedW, uint32_t *EnergyProducedWh) {
  return dsm_api_mock.CircuitEnergyMeterValue_get(handle, dS485DeviceUID, PowerW, EnergyWh, PowerProducedW,
                                                  EnergyProducedWh);
}

int CircuitEnergyMeterValue_reset(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *PowerW, uint32_t *EnergyWh,
                                  uint32_t *PowerProducedW, uint32_t *EnergyProducedWh) {
  return dsm_api_mock.CircuitEnergyMeterValue_reset(handle, dS485DeviceUID, PowerW, EnergyWh, PowerProducedW,
                                                    EnergyProducedWh);
}

int CircuitEnergyMeterValue_calibration(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Uaverage, uint16_t *I14average, uint16_t *I180average, uint32_t *PActiveLow, uint32_t *PActiveHigh)
{
    return dsm_api_mock.CircuitEnergyMeterValue_calibration(handle, dS485DeviceUID, Uaverage, I14average, I180average, PActiveLow, PActiveHigh);
}

int CircuitEnergyMeterValue_Ws_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *PowerW, uint32_t *EnergyWs,
                                   uint32_t *PowerProducedW, uint32_t *EnergyProducedWs) {
  return dsm_api_mock.CircuitEnergyMeterValue_Ws_get(handle, dS485DeviceUID, PowerW, EnergyWs, PowerProducedW,
                                                     EnergyProducedWs);
}

int CircuitCurrentMeterValue_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *PowerW, uint16_t *PowerQ, uint16_t *Phi)
{
    return dsm_api_mock.CircuitCurrentMeterValue_get(handle, dS485DeviceUID, PowerW, PowerQ, Phi);
}

int CircuitPowerState_max_count(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *MaxCount)
{
    return dsm_api_mock.CircuitPowerState_max_count(handle, dS485DeviceUID, MaxCount);
}

int CircuitPowerState_get(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Index, uint8_t *IndexResp, uint8_t *State, uint32_t *SetThreshold, uint32_t *ResetThreshold)
{
    return dsm_api_mock.CircuitPowerState_get(handle, dS485DeviceUID, Index, IndexResp, State, SetThreshold, ResetThreshold);
}

int CircuitPowerState_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Index, uint32_t SetThreshold, uint32_t ResetThreshold)
{
    return dsm_api_mock.CircuitPowerState_config(handle, dS485DeviceUID, Index, SetThreshold, ResetThreshold);
}

int dSMInfo(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *HWVersion, uint32_t *ARMSWVersion, uint32_t *DSPSWVersion, uint16_t *ApiVersion, dsid_t *DSID, uint8_t *Name)
{
    return dsm_api_mock.dSMInfo(handle, dS485DeviceUID, HWVersion, ARMSWVersion, DSPSWVersion, ApiVersion, DSID, Name);
}

int dSMProperties_set_name(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, const uint8_t *Name)
{
    return dsm_api_mock.dSMProperties_set_name(handle, dS485DeviceUID, Name);
}

int dSMProperties_set_apartment_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t ApartmentId)
{
    return dsm_api_mock.dSMProperties_set_apartment_id(handle, dS485DeviceUID, ApartmentId);
}

int dSMProperties_set_temperature_limits(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t WarnTemperature, uint8_t ErrorTemperature)
{
    return dsm_api_mock.dSMProperties_set_temperature_limits(handle, dS485DeviceUID, WarnTemperature, ErrorTemperature);
}

int dSMProperties_get_apartment_id(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *ApartmentId)
{
    return dsm_api_mock.dSMProperties_get_apartment_id(handle, dS485DeviceUID, ApartmentId);
}

int dSMProperties_get_temperature_limits(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *WarnTemperature, uint8_t *ErrorTemperature)
{
    return dsm_api_mock.dSMProperties_get_temperature_limits(handle, dS485DeviceUID, WarnTemperature, ErrorTemperature);
}

int dSMProperties_get_current_temperature(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Temperature)
{
    return dsm_api_mock.dSMProperties_get_current_temperature(handle, dS485DeviceUID, Temperature);
}

int dSMProperties_set_flags(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Flags)
{
    return dsm_api_mock.dSMProperties_set_flags(handle, dS485DeviceUID, Flags);
}

int dSMProperties_get_flags(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Flags)
{
    return dsm_api_mock.dSMProperties_get_flags(handle, dS485DeviceUID, Flags);
}

int dSMProperties_get_power_down_duration(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Duration)
{
    return dsm_api_mock.dSMProperties_get_power_down_duration(handle, dS485DeviceUID, Duration);
}

int dSMProperties_set_ping_intervals(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t AutoPingInterval, uint16_t OnePingInterval)
{
    return dsm_api_mock.dSMProperties_set_ping_intervals(handle, dS485DeviceUID, AutoPingInterval, OnePingInterval);
}

int dSMProperties_get_ping_intervals(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *AutoPingInterval, uint16_t *OnePingInterval)
{
    return dsm_api_mock.dSMProperties_get_ping_intervals(handle, dS485DeviceUID, AutoPingInterval, OnePingInterval);
}

int dSMProperties_get_max_temperature(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *MaxTemperature)
{
    return dsm_api_mock.dSMProperties_get_max_temperature(handle, dS485DeviceUID, MaxTemperature);
}

int dSMProperties_reset_max_temperature(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMProperties_reset_max_temperature(handle, dS485DeviceUID);
}

int dSMProperties_set_upstream_frequency(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t UpstreamFrequency)
{
    return dsm_api_mock.dSMProperties_set_upstream_frequency(handle, dS485DeviceUID, UpstreamFrequency);
}

int dSMProperties_get_upstream_frequency(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *UpstreamFrequency)
{
    return dsm_api_mock.dSMProperties_get_upstream_frequency(handle, dS485DeviceUID, UpstreamFrequency);
}

int dSMProperties_get_apartment_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *State)
{
    return dsm_api_mock.dSMProperties_get_apartment_state(handle, dS485DeviceUID, State);
}

int dSMProperties_set_ping_intervals_s(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t AutoPingInterval, uint16_t OnePingInterval)
{
    return dsm_api_mock.dSMProperties_set_ping_intervals_s(handle, dS485DeviceUID, AutoPingInterval, OnePingInterval);
}

int dSMProperties_get_ping_intervals_s(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *AutoPingInterval, uint16_t *OnePingInterval)
{
    return dsm_api_mock.dSMProperties_get_ping_intervals_s(handle, dS485DeviceUID, AutoPingInterval, OnePingInterval);
}

int dSMState(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Hardware, uint8_t *DSP, uint8_t *Temperature, uint8_t *Config, uint8_t *dS485, uint8_t *Line)
{
    return dsm_api_mock.dSMState(handle, dS485DeviceUID, Hardware, DSP, Temperature, Config, dS485, Line);
}

int dSMConfig_set_dSM_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, dsid_t DSID, uint32_t HWVersion)
{
    return dsm_api_mock.dSMConfig_set_dSM_config(handle, dS485DeviceUID, DSID, HWVersion);
}

int dSMConfig_get_DSP_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Size, uint8_t *Config)
{
    return dsm_api_mock.dSMConfig_get_DSP_config(handle, dS485DeviceUID, Size, Config);
}

int dSMConfig_set_DSP_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Size, const uint8_t *Config)
{
    return dsm_api_mock.dSMConfig_set_DSP_config(handle, dS485DeviceUID, Size, Config);
}

int dSMConfig_get_hash(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *Hash, uint32_t *ConfigurationCount, uint32_t *BinaryInputEventCount)
{
    return dsm_api_mock.dSMConfig_get_hash(handle, dS485DeviceUID, Hash, ConfigurationCount, BinaryInputEventCount);
}

int UserProtobufMessageRequest(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t Request_Size, const uint8_t *Request, uint16_t *Response_Size, uint8_t *Response)
{
    return dsm_api_mock.UserProtobufMessageRequest(handle, dS485DeviceUID, Request_Size, Request, Response_Size, Response);
}



int dSMStatistics_reset_dS485(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMStatistics_reset_dS485(handle, dS485DeviceUID);
}

int dSMStatistics_get_upstream(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Index, uint8_t *Length, uint8_t *Statistics)
{
    return dsm_api_mock.dSMStatistics_get_upstream(handle, dS485DeviceUID, Index, Length, Statistics);
}

int dSMStatistics_reset_upstream(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMStatistics_reset_upstream(handle, dS485DeviceUID);
}

int dSMStatistics_get_internals(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *RxShortUpstream, uint32_t *RxLongUpstream, uint32_t *TxDownstream, uint32_t *TxErrorSelectA, uint32_t *TxErrorSelectB, uint32_t *DSPResets, uint32_t *DSPMsgSizeError, uint32_t *DSPMsgMagicError, uint32_t *DSPMsgUnknown)
{
    return dsm_api_mock.dSMStatistics_get_internals(handle, dS485DeviceUID, RxShortUpstream, RxLongUpstream, TxDownstream, TxErrorSelectA, TxErrorSelectB, DSPResets, DSPMsgSizeError, DSPMsgMagicError, DSPMsgUnknown);
}

int dSMStatistics_reset_internals(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMStatistics_reset_internals(handle, dS485DeviceUID);
}



int dSMStatistics_get_stop_timer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Index, uint8_t *LocalZoneId, uint8_t *GroupId, uint8_t *ButtonId, uint8_t *TimeOut, uint32_t *TimerCount)
{
    return dsm_api_mock.dSMStatistics_get_stop_timer(handle, dS485DeviceUID, Index, LocalZoneId, GroupId, ButtonId, TimeOut, TimerCount);
}

int dSMReboot(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMReboot(handle, dS485DeviceUID);
}

int dSMFactoryReset(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t Password)
{
    return dsm_api_mock.dSMFactoryReset(handle, dS485DeviceUID, Password);
}

int ImageMaintenance_check_image(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *ReadCRC, uint16_t *ComputedCRC)
{
    return dsm_api_mock.ImageMaintenance_check_image(handle, dS485DeviceUID, ReadCRC, ComputedCRC);
}

int ImageMaintenance_get_image_info(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *ManufacturerId, uint32_t *DeviceId, uint32_t *ContentType, uint32_t *ContentSize, uint16_t *ContentCRC)
{
    return dsm_api_mock.ImageMaintenance_get_image_info(handle, dS485DeviceUID, ManufacturerId, DeviceId, ContentType, ContentSize, ContentCRC);
}

int ImageMaintenance_start_update(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.ImageMaintenance_start_update(handle, dS485DeviceUID);
}

int ImageMaintenance_remove_image(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.ImageMaintenance_remove_image(handle, dS485DeviceUID);
}

int ImageTransfer_write_request(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t ManufacturerId, uint32_t DeviceId, uint32_t ContentType, uint32_t ContentSize, uint16_t ContentCRC)
{
    return dsm_api_mock.ImageTransfer_write_request(handle, dS485DeviceUID, ManufacturerId, DeviceId, ContentType, ContentSize, ContentCRC);
}

int ImageTransfer_data(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t PacketNr, const uint8_t *Data, uint32_t *ExpectedPacketNr, uint32_t *ReceivedPacketNr)
{
    return dsm_api_mock.ImageTransfer_data(handle, dS485DeviceUID, PacketNr, Data, ExpectedPacketNr, ReceivedPacketNr);
}

int dSFInfo(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t *HWVersion, uint32_t *ARMSWVersion, uint32_t *DSPSWVersion, uint32_t *BoosterARMSWVersion, uint16_t *ApiVersion, dsid_t *DSID, uint8_t *Name)
{
    return dsm_api_mock.dSFInfo(handle, dS485DeviceUID, HWVersion, ARMSWVersion, DSPSWVersion, BoosterARMSWVersion, ApiVersion, DSID, Name);
}

int dSFStatistics_get_DSP(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t Page, uint8_t *Length, uint8_t *Statistics)
{
    return dsm_api_mock.dSFStatistics_get_DSP(handle, dS485DeviceUID, DspPhase, Page, Length, Statistics);
}

int dSFStatistics_reset_DSP(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase)
{
    return dsm_api_mock.dSFStatistics_reset_DSP(handle, dS485DeviceUID, DspPhase);
}

int dSFStatistics_get_booster(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Page, uint8_t *Length, uint8_t *Statistics)
{
    return dsm_api_mock.dSFStatistics_get_booster(handle, dS485DeviceUID, Page, Length, Statistics);
}

int dSFStatistics_reset_booster(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSFStatistics_reset_booster(handle, dS485DeviceUID);
}

int dSFStatistics_get_ARM(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Page, uint8_t *Length, uint8_t *Statistics)
{
    return dsm_api_mock.dSFStatistics_get_ARM(handle, dS485DeviceUID, Page, Length, Statistics);
}

int dSFStatistics_reset_ARM(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSFStatistics_reset_ARM(handle, dS485DeviceUID);
}



int dSFStatistics_get_grid_quality(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Phase, uint8_t Page, uint8_t *TotalSize, uint8_t *Size, uint8_t *GridQuality)
{
    return dsm_api_mock.dSFStatistics_get_grid_quality(handle, dS485DeviceUID, Phase, Page, TotalSize, Size, GridQuality);
}

int dSFStatistics_get_20k_band_fft(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Phase, uint8_t Page, uint16_t *TotalSize, uint8_t *Size, uint8_t *GridQuality)
{
    return dsm_api_mock.dSFStatistics_get_20k_band_fft(handle, dS485DeviceUID, Phase, Page, TotalSize, Size, GridQuality);
}

int dSFState(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Hardware, uint8_t *ARM, uint8_t *DSP1, uint8_t *DSP2, uint8_t *DSP3, uint8_t *BoosterARM, uint8_t *Temperature, uint8_t *Config, uint8_t *ds485)
{
    return dsm_api_mock.dSFState(handle, dS485DeviceUID, Hardware, ARM, DSP1, DSP2, DSP3, BoosterARM, Temperature, Config, ds485);
}

int dSFConfig_set_DSP_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t Size, const uint8_t *Config)
{
    return dsm_api_mock.dSFConfig_set_DSP_config(handle, dS485DeviceUID, DspPhase, Size, Config);
}

int dSFConfig_get_DSP_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t *Size, uint8_t *Config)
{
    return dsm_api_mock.dSFConfig_get_DSP_config(handle, dS485DeviceUID, DspPhase, Size, Config);
}

int dSFConfig_set_dSF_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, dsid_t DSID, uint32_t HWVersion)
{
    return dsm_api_mock.dSFConfig_set_dSF_config(handle, dS485DeviceUID, DSID, HWVersion);
}

int dSFConfig_set_booster_arm_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Size, const uint8_t *Config)
{
    return dsm_api_mock.dSFConfig_set_booster_arm_config(handle, dS485DeviceUID, Size, Config);
}

int dSFConfig_get_booster_arm_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Size, uint8_t *Config)
{
    return dsm_api_mock.dSFConfig_get_booster_arm_config(handle, dS485DeviceUID, Size, Config);
}

int dSFFilter_start_probing(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t ProbingMode)
{
    return dsm_api_mock.dSFFilter_start_probing(handle, dS485DeviceUID, DspPhase, ProbingMode);
}

int dSFFilter_set_coeffs(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t FilterIndex, uint8_t Page, uint8_t TotalSize, uint8_t Size, const uint8_t *Coeffs)
{
    return dsm_api_mock.dSFFilter_set_coeffs(handle, dS485DeviceUID, DspPhase, FilterIndex, Page, TotalSize, Size, Coeffs);
}

int dSFFilter_get_coeffs(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t FilterIndex, uint8_t Page, uint8_t *TotalSize, uint8_t *Size, uint8_t *Coeffs)
{
    return dsm_api_mock.dSFFilter_get_coeffs(handle, dS485DeviceUID, DspPhase, FilterIndex, Page, TotalSize, Size, Coeffs);
}

int dSFFilter_unfreeze_filter(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t FilterIndex, uint8_t Unfreeze)
{
    return dsm_api_mock.dSFFilter_unfreeze_filter(handle, dS485DeviceUID, DspPhase, FilterIndex, Unfreeze);
}

int dSFDebugMode_restart_dsp(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase)
{
    return dsm_api_mock.dSFDebugMode_restart_dsp(handle, dS485DeviceUID, DspPhase);
}

int dSFDebugMode_restart_booster_arm(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSFDebugMode_restart_booster_arm(handle, dS485DeviceUID);
}

int dSFDebugMode_watchdog_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DSP, uint8_t BoosterARM)
{
    return dsm_api_mock.dSFDebugMode_watchdog_state(handle, dS485DeviceUID, DSP, BoosterARM);
}

int dSFDebugMode_erase_config(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Processor)
{
    return dsm_api_mock.dSFDebugMode_erase_config(handle, dS485DeviceUID, Processor);
}

int dSFDebugMode_generator_mode(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint16_t Amplitude, uint32_t Frequency)
{
    return dsm_api_mock.dSFDebugMode_generator_mode(handle, dS485DeviceUID, DspPhase, Amplitude, Frequency);
}

int dSFDebugMode_compensation_mode(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DspPhase, uint8_t have_2kRC, uint8_t have_2kCP, uint8_t have_20k)
{
    return dsm_api_mock.dSFDebugMode_compensation_mode(handle, dS485DeviceUID, DspPhase, have_2kRC, have_2kCP, have_20k);
}

int dSFBooster_set_booster_enable(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t PhaseNr, uint8_t EnableRising, uint8_t EnableFalling)
{
    return dsm_api_mock.dSFBooster_set_booster_enable(handle, dS485DeviceUID, PhaseNr, EnableRising, EnableFalling);
}

int dSFBooster_get_booster_enable(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t PhaseNr, uint8_t *EnabledRising, uint8_t *EnabledFalling)
{
    return dsm_api_mock.dSFBooster_get_booster_enable(handle, dS485DeviceUID, PhaseNr, EnabledRising, EnabledFalling);
}

int dSFBooster_set_window_timing(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t PhaseNr, uint16_t EnableRisingTime, uint16_t DisableRisingTime, uint16_t EnableFallingTime, uint16_t DisableFallingTime)
{
    return dsm_api_mock.dSFBooster_set_window_timing(handle, dS485DeviceUID, PhaseNr, EnableRisingTime, DisableRisingTime, EnableFallingTime, DisableFallingTime);
}

int dSFBooster_get_window_timing(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t PhaseNr, uint16_t *EnabledRisingTime, uint16_t *DisabledRisingTime, uint16_t *EnabledFallingTime, uint16_t *DisabledFallingTime)
{
    return dsm_api_mock.dSFBooster_get_window_timing(handle, dS485DeviceUID, PhaseNr, EnabledRisingTime, DisabledRisingTime, EnabledFallingTime, DisabledFallingTime);
}

int dSFBooster_set_min_max_period(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t PhaseNr, uint16_t MinPeriod, uint16_t MaxPeriod)
{
    return dsm_api_mock.dSFBooster_set_min_max_period(handle, dS485DeviceUID, PhaseNr, MinPeriod, MaxPeriod);
}

int dSFBooster_set_booster_event_threshold(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t Threshold)
{
    return dsm_api_mock.dSFBooster_set_booster_event_threshold(handle, dS485DeviceUID, Threshold);
}

int dSFBooster_get_booster_event_threshold(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Threshold)
{
    return dsm_api_mock.dSFBooster_get_booster_event_threshold(handle, dS485DeviceUID, Threshold);
}

int dSFProperties_get_current_temperature_top(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Temperature)
{
    return dsm_api_mock.dSFProperties_get_current_temperature_top(handle, dS485DeviceUID, Temperature);
}

int dSFProperties_set_temperature_limits_booster(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t MaxTemperature, uint8_t SafeTemperature)
{
    return dsm_api_mock.dSFProperties_set_temperature_limits_booster(handle, dS485DeviceUID, MaxTemperature, SafeTemperature);
}

int dSFProperties_get_temperature_limits_booster(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *MaxTemperature, uint8_t *SafeTemperature)
{
    return dsm_api_mock.dSFProperties_get_temperature_limits_booster(handle, dS485DeviceUID, MaxTemperature, SafeTemperature);
}

int dSFProperties_get_max_temperature_top(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Temperature)
{
    return dsm_api_mock.dSFProperties_get_max_temperature_top(handle, dS485DeviceUID, Temperature);
}

int dSFProperties_reset_max_temperature_top(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSFProperties_reset_max_temperature_top(handle, dS485DeviceUID);
}

int dSFProperties_get_current_temperature_bottom(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *Temperature)
{
    return dsm_api_mock.dSFProperties_get_current_temperature_bottom(handle, dS485DeviceUID, Temperature);
}

int dSFProperties_get_max_temperature_bottom(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t *MaxTemperature)
{
    return dsm_api_mock.dSFProperties_get_max_temperature_bottom(handle, dS485DeviceUID, MaxTemperature);
}

int dSFProperties_reset_max_temperature_bottom(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSFProperties_reset_max_temperature_bottom(handle, dS485DeviceUID);
}

int dSFProperties_set_temperature_limits_device(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t WarnTemperature, uint8_t ErrorTemperature)
{
    return dsm_api_mock.dSFProperties_set_temperature_limits_device(handle, dS485DeviceUID, WarnTemperature, ErrorTemperature);
}

int dSFProperties_get_temperature_limits_device(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *WarnTemperature, uint8_t *ErrorTemperature)
{
    return dsm_api_mock.dSFProperties_get_temperature_limits_device(handle, dS485DeviceUID, WarnTemperature, ErrorTemperature);
}

int dSFImageMaintenance_check_image(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t DeviceId, uint16_t *ReadCRC, uint16_t *ComputedCRC)
{
    return dsm_api_mock.dSFImageMaintenance_check_image(handle, dS485DeviceUID, DeviceId, ReadCRC, ComputedCRC);
}

int dSFImageMaintenance_remove_image(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t DeviceId)
{
    return dsm_api_mock.dSFImageMaintenance_remove_image(handle, dS485DeviceUID, DeviceId);
}

int dSFImageMaintenance_start_update(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t DeviceId)
{
    return dsm_api_mock.dSFImageMaintenance_start_update(handle, dS485DeviceUID, DeviceId);
}

int dSFImageMaintenance_get_image_info(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t DeviceId, uint32_t *ManufacturerId, uint32_t *ActualDeviceId, uint32_t *ContentType, uint32_t *ContentSize, uint32_t *ContentCRC)
{
    return dsm_api_mock.dSFImageMaintenance_get_image_info(handle, dS485DeviceUID, DeviceId, ManufacturerId, ActualDeviceId, ContentType, ContentSize, ContentCRC);
}

int RemoveVdc(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, dsuid_t dSUID)
{
    return dsm_api_mock.RemoveVdc(handle, dS485DeviceUID, dSUID);
}

int ZoneGroupDslinkSend_not_last_byte_no_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t Value)
{
    return dsm_api_mock.ZoneGroupDslinkSend_not_last_byte_no_answer(handle, dS485DeviceUID, ZoneId, GroupId, Value);
}

int ZoneGroupDslinkSend_last_byte_no_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t ZoneId, uint8_t GroupId, uint8_t Value)
{
    return dsm_api_mock.ZoneGroupDslinkSend_last_byte_no_answer(handle, dS485DeviceUID, ZoneId, GroupId, Value);
}

int DeviceDslinkSend_not_last_byte_no_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Value)
{
    return dsm_api_mock.DeviceDslinkSend_not_last_byte_no_answer(handle, dS485DeviceUID, DeviceId, Value);
}

int DeviceDslinkSend_last_byte_no_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Value)
{
    return dsm_api_mock.DeviceDslinkSend_last_byte_no_answer(handle, dS485DeviceUID, DeviceId, Value);
}

int DeviceDslinkSend_not_last_byte_with_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Value)
{
    return dsm_api_mock.DeviceDslinkSend_not_last_byte_with_answer(handle, dS485DeviceUID, DeviceId, Value);
}

int DeviceDslinkSend_last_byte_with_answer(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t DeviceId, uint8_t Value)
{
    return dsm_api_mock.DeviceDslinkSend_last_byte_with_answer(handle, dS485DeviceUID, DeviceId, Value);
}

int BusMember_get_type(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *Type)
{
    return dsm_api_mock.BusMember_get_type(handle, dS485DeviceUID, Type);
}

int dSMDebugMode_set_MMI_flag(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t DebugFlag)
{
    return dsm_api_mock.dSMDebugMode_set_MMI_flag(handle, dS485DeviceUID, DebugFlag);
}

int dSMDebugMode_get_MMI_flag(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *DebugFlag)
{
    return dsm_api_mock.dSMDebugMode_get_MMI_flag(handle, dS485DeviceUID, DebugFlag);
}

int dSMDebugMode_stop_select_b(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMDebugMode_stop_select_b(handle, dS485DeviceUID);
}

int dSMDebugMode_restart_registration(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMDebugMode_restart_registration(handle, dS485DeviceUID);
}

int dSMDebugMode_restart_dsp(DsmApiHandle_t handle, dsuid_t dS485DeviceUID)
{
    return dsm_api_mock.dSMDebugMode_restart_dsp(handle, dS485DeviceUID);
}

int dSMDebugMode_read_flash(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t Index, uint8_t *Data)
{
    return dsm_api_mock.dSMDebugMode_read_flash(handle, dS485DeviceUID, Index, Data);
}

int dSMDebugMode_write_flash(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint32_t Index, const uint8_t *Data)
{
    return dsm_api_mock.dSMDebugMode_write_flash(handle, dS485DeviceUID, Index, Data);
}

int dSMDebugMode_get_communication_log_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t *State)
{
    return dsm_api_mock.dSMDebugMode_get_communication_log_state(handle, dS485DeviceUID, State);
}

int dSMDebugMode_set_communication_log_state(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t State)
{
    return dsm_api_mock.dSMDebugMode_set_communication_log_state(handle, dS485DeviceUID, State);
}

int dSMDebugMode_disable_jumble(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint8_t Disable)
{
    return dsm_api_mock.dSMDebugMode_disable_jumble(handle, dS485DeviceUID, Disable);
}

int dSMDebugMode_inject_short_upstream(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t Source, uint8_t Circuit, uint8_t Key, uint8_t Click, uint8_t Sensor, uint8_t Resend, uint8_t Quality, uint8_t Flags)
{
    return dsm_api_mock.dSMDebugMode_inject_short_upstream(handle, dS485DeviceUID, Source, Circuit, Key, Click, Sensor, Resend, Quality, Flags);
}

int dSMDebugMode_inject_long_upstream(DsmApiHandle_t handle, dsuid_t dS485DeviceUID, uint16_t Source, uint8_t Circuit, uint8_t Mainqualifier, uint8_t Subqualifier, uint32_t Data, uint8_t Quality, uint8_t Flags)
{
    return dsm_api_mock.dSMDebugMode_inject_long_upstream(handle, dS485DeviceUID, Source, Circuit, Mainqualifier, Subqualifier, Data, Quality, Flags);
}
}
