/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include "archives-connection.h"

#include <trompeloeil.hpp>

#include "rrd-interface.h"

namespace dss::metering {

struct RRDInterfaceMock : public trompeloeil::mock_interface<RRDInterface> {
  IMPLEMENT_MOCK4(create);
  IMPLEMENT_MOCK1(info);
  IMPLEMENT_MOCK1(tune);
  IMPLEMENT_MOCK1(update);
  IMPLEMENT_MOCK1(flush);
  IMPLEMENT_MOCK1(lastValue);
  IMPLEMENT_MOCK1(lastTimestamp);
  IMPLEMENT_MOCK1(xport);
};

struct ArchivesConnectionMock : public trompeloeil::mock_interface<dss::metering::ArchivesConnection> {
  IMPLEMENT_CONST_MOCK0(getArchivesStorage);
  IMPLEMENT_CONST_MOCK0(restartCached);
  IMPLEMENT_CONST_MOCK0(rrdCachedPath);
  IMPLEMENT_CONST_MOCK0(rrdInterface);
  IMPLEMENT_CONST_MOCK1(flush);
  IMPLEMENT_CONST_MOCK1(lastTimestamp);
  IMPLEMENT_MOCK1(setRRDCachedPath);
};

} // namespace dss::metering
