#pragma once

#include <metering/metering-fwd.h>
#include <metering/power-states-fwd.h>
#include <model/apartment.h>

namespace dss::metering {

struct TotalPower {
  unsigned int production;
  unsigned int consumption;
};

class PowerStates {
public:
  virtual ~PowerStates() = default;
  virtual std::shared_ptr<State> createState(std::string meteringId, PowerStateConfig&& powerStateConfig) = 0;
  virtual void removeState(std::string meteringId, const PowerStateConfig& powerStateConfig) = 0;
  virtual void trigger(std::string meteringId, TotalPower&& totalPower) = 0;
};

std::shared_ptr<PowerStates> makePowerStates(Apartment& apartment);

} // namespace dss::metering

DS_REFLECT_STRUCT((dss::metering), TotalPower, (production)(consumption));
