/*
    Copyright (c) 2014 digitalSTROM AG, Zurich, Switzerland

    Author: Sergey Jin Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <string>
#include <vector>

#include "model/modelconst.h"

namespace dss {

class ModelFeatures {
public:
  using features_t = std::vector<std::vector<ModelFeatureId>>;

  virtual ~ModelFeatures() = default;
  virtual void setFeatures(int _color, const std::string& model, std::vector<ModelFeatureId>&& features) = 0;
  virtual std::vector<std::pair<std::string, features_t>> getFeatures(int _color) = 0;

  std::string colorToString(int _color);
  virtual std::vector<ModelFeatureId> getAvailableFeatures() const = 0;
};

std::unique_ptr<ModelFeatures> makeModelFeatures();

}; // namespace dss
