/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <ds/reflect.h>

#include "ds-model/devices.h"
#include "model/data_types.h"

namespace dss::model {

struct ShadeAttributes {
  CardinalDirection_t cardinalDirection = cd_none;
  WindProtectionClass_t windProtectionClass = wpc_none;
  dsModel::ShadeType shadeType{};
};

} // namespace dss::model

DS_REFLECT_STRUCT((dss::model), ShadeAttributes, (cardinalDirection)(windProtectionClass)(shadeType))
