
#include "config-file.h"

#include <filesystem>

static ds::LogChannel dsLogChannel("dssP1ConfigFile");

namespace dss::p1 {

ConfigFile loadConfigFile(ds::System& system) {
  auto filePath = std::filesystem::path(system.dirs().sysconfdir) / "p1-config.json";
  DS_NOTICE("Load configuration", filePath.string());
  auto file = system.readFileIfExists(filePath.string());
  if (!file) {
    DS_NOTICE("File not found. Load default configuration.");
    return ConfigFile{};
  }
  return ds::fromJson<ConfigFile>(*file);
}

} // namespace dss::p1

DS_JSON_DEFINE_STRUCT((dss::p1), ConfigFile);
DS_JSON_DEFINE_STRUCT((dss::p1), SerialPortConfig);
